## ros-noetic-web-video-server 0.2.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(web_video_server)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS roscpp roslib cv_bridge image_transport async_web_server_cpp sensor_msgs)
find_package(OpenCV REQUIRED)
find_package(Boost REQUIRED COMPONENTS thread)

find_package(PkgConfig REQUIRED)
pkg_check_modules(avcodec libavcodec REQUIRED)
pkg_check_modules(avformat libavformat REQUIRED)
pkg_check_modules(avutil libavutil REQUIRED)
pkg_check_modules(swscale libswscale REQUIRED)

###################################################
## Declare things to be passed to other projects ##
###################################################

## LIBRARIES: libraries you create in this project that dependent projects also need
## CATKIN_DEPENDS: catkin_packages dependent projects also need
## DEPENDS: system dependencies of this project that dependent projects also need
catkin_package()

###########
## Build ##
###########

## Specify additional locations of header files
include_directories(include
  ${catkin_INCLUDE_DIRS}
  ${Boost_INCLUDE_DIRS}
  ${avcodec_INCLUDE_DIRS}
  ${avformat_INCLUDE_DIRS}
  ${avutil_INCLUDE_DIRS}
  ${swscale_INCLUDE_DIRS}
)

## Declare a cpp executable
add_executable(${PROJECT_NAME}
  src/web_video_server.cpp
  src/image_streamer.cpp
  src/libav_streamer.cpp
  src/vp8_streamer.cpp
  src/h264_streamer.cpp
  src/vp9_streamer.cpp
  src/multipart_stream.cpp
  src/ros_compressed_streamer.cpp
  src/jpeg_streamers.cpp
  src/png_streamers.cpp
)

## Specify libraries to link a library or executable target against
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  ${OpenCV_LIBS}
  ${avcodec_LIBRARIES}
  ${avformat_LIBRARIES}
  ${avutil_LIBRARIES}
  ${swscale_LIBRARIES}
)

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
   FILES_MATCHING PATTERN "*.h" PATTERN "*.hpp"
)

=== debian/changelog ===
ros-noetic-web-video-server (0.2.2-1focal) focal; urgency=high

  * fix vp9 and h264, support for opencv4 and ffmpeg 4 (#103 <https://github.com/RobotWebTools/web_video_server/issues/103>)
  * add a mention of mjpegcanvasjs in the readme (#100 <https://github.com/RobotWebTools/web_video_server/issues/100>)
  * fix multipart_stream.cpp HttpHeader values in order to solve DOMException(cross origin) CORS issue (#92 <https://github.com/RobotWebTools/web_video_server/issues/92>)
  * Contributors: Gady, okapi1125, randoms

 -- Russell Toris <rctoris@wpi.edu>  Thu, 22 Jul 2021 15:00:00 -0000

ros-noetic-web-video-server (0.2.1-1focal) focal; urgency=high

  * Restream buffered frames with minimum publish rate (#88 <https://github.com/RobotWebTools/web_video_server/issues/88>)
    * Restream buffered frames with minimum publish rate
    * Implement restreaming for ros_compressed_streamer
  * Update travis config (#89 <https://github.com/RobotWebTools/web_video_server/issues/89>)
  * Fall back to mjpeg if ros_compressed is unavailable (#87 <https://github.com/RobotWebTools/web_video_server/issues/87>)
  * Contributors: Jihoon Lee, Viktor Kunovski, sfalexrog

 -- Russell Toris <rctoris@wpi.edu>  Tue, 04 Jun 2019 15:00:00 -0000

ros-noetic-web-video-server (0.2.0-1focal) focal; urgency=high

  * Add "default_stream_type" parameter (#84 <https://github.com/RobotWebTools/web_video_server/issues/84>)
    This allows users to specify default stream type in their .launch files. Using a "ros_compressed" stream type sometimes
    results in a much lower resource consumption, and having it set as a default is much nicer for end users.
  * Add a workaround for MultipartStream constant busy state (#83 <https://github.com/RobotWebTools/web_video_server/issues/83>)
    * Add a workaround for MultipartStream constant busy state
    * Remove C++11 features
  * lax rule for topic name (#77 <https://github.com/RobotWebTools/web_video_server/issues/77>)
  * Add PngStreamer (#74 <https://github.com/RobotWebTools/web_video_server/issues/74>)
  * fix SteadyTimer check for backported ROS versions (#71 <https://github.com/RobotWebTools/web_video_server/issues/71>)
    i.e. on current kinetic
  * Pkg format 2 (#68 <https://github.com/RobotWebTools/web_video_server/issues/68>)
    * use package format 2
    * add missing dependency on sensor_msgs
  * fixed undeclared CODEC_FLAG_GLOBAL_HEADER (#65 <https://github.com/RobotWebTools/web_video_server/issues/65>)
  * Contributors: Andreas Klintberg, Dirk Thomas, Felix Ruess, Kazuto Murase, Viktor Kunovski, sfalexrog

 -- Russell Toris <rctoris@wpi.edu>  Tue, 29 Jan 2019 15:00:00 -0000

ros-noetic-web-video-server (0.1.0-1focal) focal; urgency=high

  * Avoid queuing of images on slow ethernet connection (#64 <https://github.com/RobotWebTools/web_video_server/issues/64>)
  * use SteadyTimer (if available) for cleaning up inactive streams (#63 <https://github.com/RobotWebTools/web_video_server/issues/63>)
    * use SteadyTimer for cleaning up inactive streams
    so that cleanup works correctly even if system time changes
    SteadyTimer is available since roscpp 1.13.1
    * possibility to use SteadyTimer on older ROS versions
    when SteadyTimer has been backported to those...
  * Fix segfault in libav_streamer destructor (resolves #59 <https://github.com/RobotWebTools/web_video_server/issues/59>) (#60 <https://github.com/RobotWebTools/web_video_server/issues/60>)
  * Fix vp8 in kinetic add vp9 and h264 support (#52 <https://github.com/RobotWebTools/web_video_server/issues/52>)
    * fix vp8 in kinetic
    * add h264 and vp9 support
  * Add Indigo test matrix in travis configuration (#50 <https://github.com/RobotWebTools/web_video_server/issues/50>)
  * Set image streamer as inactive if topic is not available (#53 <https://github.com/RobotWebTools/web_video_server/issues/53>)
    * Resolves #38 <https://github.com/RobotWebTools/web_video_server/issues/38>
  * Fix Build for ubuntu 14.04 (#48 <https://github.com/RobotWebTools/web_video_server/issues/48>)
    * fix issue #47 <https://github.com/RobotWebTools/web_video_server/issues/47>
    * fix double free
  * Revert "use SteadyTimer for cleaning up inactive streams (#45 <https://github.com/RobotWebTools/web_video_server/issues/45>)" (#51 <https://github.com/RobotWebTools/web_video_server/issues/51>)
    This reverts commit ae74f19ada22f288a7c7a99ada7a1b9b6037c7ce.
  * use SteadyTimer for cleaning up inactive streams (#45 <https://github.com/RobotWebTools/web_video_server/issues/45>)
    so that cleanup works correctly even if system time changes
  * Use trusty instead of xenial.  See travis-ci/travis-ci#7260 <https://github.com/travis-ci/travis-ci/issues/7260> (#49 <https://github.com/RobotWebTools/web_video_server/issues/49>)
    * Also see RobotWebTools/rosbridge_suite#311 <https://github.com/RobotWebTools/rosbridge_suite/issues/311>
  * Contributors: Felix Ruess, James Bailey, Jihoon Lee, randoms, schallerr

 -- Russell Toris <rctoris@wpi.edu>  Sat, 30 Jun 2018 15:00:00 -0000

ros-noetic-web-video-server (0.0.7-1focal) focal; urgency=high

  * Ffmpeg 3 (#43 <https://github.com/RobotWebTools/web_video_server/issues/43>)
    * Correct use of deprecated parameters
    codec_context_->rc_buffer_aggressivity marked as "currently useless", so removed
    codec_context_->frame_skip_threshold access through new priv_data api
    * New names for pixel formats
    * AVPicture is deprecated, use AVFrame
    * Switch to non-deprecated free functions
    * Use new encoding api for newer versions
    * codec_context is deprecated, use packet flags
  * Update travis configuration to test against kinetic (#44 <https://github.com/RobotWebTools/web_video_server/issues/44>)
  * fixed misuse of remove_if (#35 <https://github.com/RobotWebTools/web_video_server/issues/35>)
  * Merge pull request #33 <https://github.com/RobotWebTools/web_video_server/issues/33> from achim-k/patch-1
    web_video_server: fix bool function not returning


=== debian/control ===
Source: ros-noetic-web-video-server
Section: misc
Priority: optional
Maintainer: Russell Toris <rctoris@wpi.edu>
Build-Depends: debhelper (>= 9.0.0), ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, ros-noetic-async-web-server-cpp, ros-noetic-catkin, ros-noetic-cv-bridge, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-roslib, ros-noetic-sensor-msgs
Homepage: http://ros.org/wiki/web_video_server
Standards-Version: 3.9.2

Package: ros-noetic-web-video-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ffmpeg, libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev, ros-noetic-async-web-server-cpp, ros-noetic-cv-bridge, ros-noetic-image-transport, ros-noetic-roscpp, ros-noetic-roslib, ros-noetic-sensor-msgs
Description: HTTP Streaming of ROS Image Topics in Multiple Formats

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-web-video-server//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
